/* Tabela INSPECAO*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INSPECAO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSPECAO, utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_CDP_INSPECAO
AFTER DELETE OR INSERT OR UPDATE
ON INSPECAO FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';
   V_CONT_LENGTH  := 1;
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_NRINCREST    := '';
   V_IDTIPOOPER   := '';
   V_CDFILLOGOPER := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

      IF INSERTING THEN 

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.NMINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.NMINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDNVINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Nvel = ' || NVL(:NEW.CDNVINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDARVINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore = ' || NVL(:NEW.CDARVINSPEC,'') || ' ';
         END IF;
         IF :NEW.IDSITINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:NEW.IDSITINSPEC,'') || ' ';
         END IF;
         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:NEW.SGUNIDADE,'') || ' ';
         END IF;
         IF :NEW.IDTPRESPINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Resposta = ' || NVL(:NEW.IDTPRESPINSP,'') || ' ';
         END IF;
         IF :NEW.DSLIMIRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Limite = ' || NVL(:NEW.DSLIMIRESP,'') || ' ';
         END IF;
         IF :NEW.IDATEITEINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Atendimento = ' || NVL(:NEW.IDATEITEINSP,'') || ' ';
         END IF;
         IF :NEW.IDORIGINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Origem = ' || NVL(:NEW.IDORIGINSPEC,'') || ' ';
         END IF;
         IF :NEW.VRCUSTOINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Custo = ' || NVL(:NEW.VRCUSTOINSP,'') || ' ';
         END IF;
         IF :NEW.CDTIPOAMOS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Amostra = ' || NVL(:NEW.CDTIPOAMOS,'') || ' ';
         END IF;
         IF :NEW.DTULTATUINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATUINSP,'') || ' ';
         END IF;
         IF :NEW.CDEXTINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Externo = ' || NVL(:NEW.CDEXTINSPEC,'') || ' ';
         END IF;
         IF :NEW.DSARQUINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Arquivo = ' || NVL(:NEW.DSARQUINSPEC,'') || ' ';
         END IF;
         IF :NEW.CDARVINSPECANTE IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore Anterior = ' || NVL(:NEW.CDARVINSPECANTE,'') || ' ';
         END IF;
         IF :NEW.IDCOMPOECUSTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Compe Custo = ' || NVL(:NEW.IDCOMPOECUSTO,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDINSPECAO;
         V_IDTIPOOPER := '1';

   ELSE

      IF UPDATING THEN

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo = ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;
         IF :NEW.NMINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:NEW.NMINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDNVINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Nvel = ' || NVL(:NEW.CDNVINSPECAO,'') || ' ';
         END IF;
         IF :NEW.CDARVINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore = ' || NVL(:NEW.CDARVINSPEC,'') || ' ';
         END IF;
         IF :NEW.IDSITINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:NEW.IDSITINSPEC,'') || ' ';
         END IF;
         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:NEW.SGUNIDADE,'') || ' ';
         END IF;
         IF :NEW.IDTPRESPINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Resposta = ' || NVL(:NEW.IDTPRESPINSP,'') || ' ';
         END IF;
         IF :NEW.DSLIMIRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Limite = ' || NVL(:NEW.DSLIMIRESP,'') || ' ';
         END IF;
         IF :NEW.IDATEITEINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Atendimento = ' || NVL(:NEW.IDATEITEINSP,'') || ' ';
         END IF;
         IF :NEW.IDORIGINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Origem = ' || NVL(:NEW.IDORIGINSPEC,'') || ' ';
         END IF;
         IF :NEW.VRCUSTOINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Custo = ' || NVL(:NEW.VRCUSTOINSP,'') || ' ';
         END IF;
         IF :NEW.CDTIPOAMOS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Amostra = ' || NVL(:NEW.CDTIPOAMOS,'') || ' ';
         END IF;
         IF :NEW.DTULTATUINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:NEW.DTULTATUINSP,'') || ' ';
         END IF;
         IF :NEW.CDEXTINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Externo = ' || NVL(:NEW.CDEXTINSPEC,'') || ' ';
         END IF;
         IF :NEW.DSARQUINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Arquivo = ' || NVL(:NEW.DSARQUINSPEC,'') || ' ';
         END IF;
         IF :NEW.CDARVINSPECANTE IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore Anterior = ' || NVL(:NEW.CDARVINSPECANTE,'') || ' ';
         END IF;
         IF :NEW.IDCOMPOECUSTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Compe Custo = ' || NVL(:NEW.IDCOMPOECUSTO,'') || ' ';
         END IF;

         V_ITPESQ     := :NEW.CDINSPECAO;
         V_IDTIPOOPER := '2';

      END IF;

      IF DELETING  THEN

         IF :OLD.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo = ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;
         IF :OLD.NMINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Inspeo = ' || NVL(:OLD.NMINSPECAO,'') || ' ';
         END IF;
         IF :OLD.CDNVINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'Nvel = ' || NVL(:OLD.CDNVINSPECAO,'') || ' ';
         END IF;
         IF :OLD.CDARVINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore = ' || NVL(:OLD.CDARVINSPEC,'') || ' ';
         END IF;
         IF :OLD.IDSITINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Situao = ' || NVL(:OLD.IDSITINSPEC,'') || ' ';
         END IF;
         IF :OLD.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'Unidade = ' || NVL(:OLD.SGUNIDADE,'') || ' ';
         END IF;
         IF :OLD.IDTPRESPINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Resposta = ' || NVL(:OLD.IDTPRESPINSP,'') || ' ';
         END IF;
         IF :OLD.DSLIMIRESP IS NOT NULL THEN
            V_DESC := V_DESC || 'Limite = ' || NVL(:OLD.DSLIMIRESP,'') || ' ';
         END IF;
         IF :OLD.IDATEITEINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Atendimento = ' || NVL(:OLD.IDATEITEINSP,'') || ' ';
         END IF;
         IF :OLD.IDORIGINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Origem = ' || NVL(:OLD.IDORIGINSPEC,'') || ' ';
         END IF;
         IF :OLD.VRCUSTOINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'Custo = ' || NVL(:OLD.VRCUSTOINSP,'') || ' ';
         END IF;
         IF :OLD.CDTIPOAMOS IS NOT NULL THEN
            V_DESC := V_DESC || 'Tipo de Amostra = ' || NVL(:OLD.CDTIPOAMOS,'') || ' ';
         END IF;
         IF :OLD.DTULTATUINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'ltima Alterao = ' || NVL(:OLD.DTULTATUINSP,'') || ' ';
         END IF;
         IF :OLD.CDEXTINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo Externo = ' || NVL(:OLD.CDEXTINSPEC,'') || ' ';
         END IF;
         IF :OLD.DSARQUINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'Arquivo = ' || NVL(:OLD.DSARQUINSPEC,'') || ' ';
         END IF;
         IF :OLD.CDARVINSPECANTE IS NOT NULL THEN
            V_DESC := V_DESC || 'Cdigo rvore Anterior = ' || NVL(:OLD.CDARVINSPECANTE,'') || ' ';
         END IF;
         IF :OLD.IDCOMPOECUSTO IS NOT NULL THEN
            V_DESC := V_DESC || 'Compe Custo = ' || NVL(:OLD.IDCOMPOECUSTO,'') || ' ';
         END IF;

         V_ITPESQ     := :OLD.CDINSPECAO;
         V_IDTIPOOPER := '3';

      END IF;
   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA,     DTOPERACAO,   NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO,   CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER,  CDFILLOGOPER)
                       VALUES  ('INSPECAO', SYSDATE,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC,    V_ITPESQ,
                                V_DSSERVERRDM,  V_DSREMOTEADDR, V_DSREMOTEHOST,
                                V_DSSERVMETHOD, V_DSREMOTEOPER, V_CDFILLOGOPER);

      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_CDP_INSPECAO','5.85.xxx'); END;
/
