/*
TECNISA - TECNOLOGIA EM INFORMTICA

NOME: APURAC_MANDATO

DESCRIO:
   PROCEDIMENTO PARA GERAO E TOTALIZAO DOS DADOS GERADOS PELA APURAO
   DE FATURAMENTO DE CLIENTES EM FILIAIS QUE UTILIZAM O TIPO DE CONTRATO MANDATO.

CRIAO:
23/09/2003 - MARINA AMARAL

@C:\WIN_v4\SQL\END_CONV\ORACLE\6209_FAISTPO.SQL;

--   RAISE_APPLICATION_ERROR(-20501,V_IDTAXAADM, TRUE);
*/

CREATE OR REPLACE PROCEDURE APURAC_RELMANDATO(
   P_CDFILIPROC  IN FILIAL.CDFILIAL%TYPE,
   P_SEQUMAND    IN RELAT_MANDATO.NRRELATMANDA%TYPE,
   P_CDCLIENTE   IN CLIENTE.CDCLIENTE%TYPE,
   P_CDFILIAPUR  IN FILIAL.CDFILIAL%TYPE,
   P_NRAPURACFAT IN NOTAFISCAL.NRAPURACFAT%TYPE,
   P_NRLANCTONF  IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_DTINIAPUR   IN DATE  DEFAULT NULL,
   P_DTFINAPUR   IN DATE  DEFAULT NULL)

IS

   V_CDEMPRATAC   EMPRESA.CDEMPRESA%TYPE;
   V_CDINSCATAC   INSCRESTAD.CDINSCESTA%TYPE;
   V_CDINSCMUNI   INSCRMUNICIP.CDINSCMUNI%TYPE;
   V_CDEMPROPER   EMPRESA.CDEMPRESA%TYPE;
   V_CDSERIE      SERIENF.CDSERIE%TYPE;
   V_CDSERIEDESP  SERIENF.CDSERIE%TYPE;
   V_CDIMPOSTO    IMPOSTO.CDIMPOSTO%TYPE;

   V_CDFILIAPUR   CTRLAPURFAT.CDFILIAPUR%TYPE;
   V_DTINIAPURAC  CTRLAPURFAT.DTINIAPURAC%TYPE;
   V_DTFIMAPURAC  CTRLAPURFAT.DTFIMAPURAC%TYPE;

   V_CONTADOR     RELAT_MANDATO.NRREGRELMAND%TYPE;
   V_VRBASENFCMP  FLOAT;

   V_CDPRGENEREV  PRODUTO.CDPRODUTO%TYPE;

   V_CDTIPOOPER   TIPOOPERAC.CDTIPOOPER%TYPE;

   V_IDTAXAADM    VARCHAR2(01);
   V_IDCALCCOMPR  VARCHAR2(01);
   V_IDRECUIMPOS  VARCHAR2(01);

   V_VRBRUTITEM   NUMBER;
   V_VRTAXAADM    NUMBER;
   V_VRTOTAXAADM  NUMBER;
   V_VRPCTXADM    NUMBER;
   V_VRLIQUFATU   NUMBER;
   V_VRPERCDESP   NUMBER;
   V_VRTOTADESP   NUMBER;
   V_VRTOTACMP    NUMBER;
   V_VRRECUIMCMP  NUMBER;
   V_VRRECUIMDES  NUMBER;
   V_VRRECUIMDET  NUMBER;

   V_NUMITENS     NUMBER;

   V_IDNFPRODREV  VARCHAR2(01);
   V_PAISORIG     VARCHAR2(04);
   V_ESTAORIG     VARCHAR2(02);
   V_MUNIORIG     VARCHAR2(04);
   V_PAISDEST     VARCHAR2(04);
   V_ESTADEST     VARCHAR2(02);
   V_IDENDCFOP    VARCHAR2(01);
   V_IDENDEMIS    VARCHAR2(01);
   V_IDGEROUNF    VARCHAR2(01);
   V_CDEMPRESA    VARCHAR2(02);
   V_CDINSCESTA   VARCHAR2(16);
   V_CDGRUPOFISC  VARCHAR2(03);

   V_SERIE        SERIENF.CDSERIE%TYPE;
   V_INSCESTA     VARCHAR2(16);
   V_INSCMUNI     INSCRMUNICIP.CDINSCMUNI%TYPE;

   V_SOMAALQIMP   NUMBER;
   V_VRCUSTOMED   NUMBER;
   V_VRALIQUTMP   NUMBER;

   V_VRTXADMPROD  NUMBER;
   V_TIPOOPER     VARCHAR2(02);
   V_VRFATOCONV   NUMBER;
   V_NMPRODUTO    VARCHAR2(50);
   V_CDPRODUTO    VARCHAR2(10);
   V_IDFATPRODCLI VARCHAR2(01);
   V_DESCIT       NUMBER;
   V_QTDESCIT     NUMBER;
   V_QTDESCIT1    NUMBER;
   V_VRTXFATNIV   NUMBER;
   V_VRDESCNFCMP  NUMBER;
   V_VRTOTCMPSTX  NUMBER;
   V_VRTOTCMPCTX  NUMBER;
   V_VRTOTDESCTX  NUMBER;
   V_VRTOTDESSTX  NUMBER;
   V_VRDOTPURPASS NUMBER;

   CURSOR C_DESPADMFATUR IS  SELECT L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT,  L.VRLANCDESFAT,
                                    D.CDGRUPOFATUR, D.CDPRODUTO, D.DSDESPADMFAT, NVL(L.VRTXLANCDESP,0) VRTAXADMFATU
                             FROM LANCDESPFATU L,  DESPADMFATUR D
                             WHERE (L.CDFILIAL = P_CDFILIAPUR)                            AND
                                   (D.CDDESPADMFAT = L.CDDESPADMFAT)                      AND
                                   (L.DTLANCDESFAT BETWEEN P_DTINIAPUR AND P_DTFINAPUR)
                             GROUP BY D.CDGRUPOFATUR, L.CDFILIAL, L.CDDESPADMFAT, L.DTLANCDESFAT, L.VRLANCDESFAT,
                                      D.CDPRODUTO, D.DSDESPADMFAT, VRTXLANCDESP;

   CURSOR C_ITEMNOTA IS
      SELECT I.CDPRODUTO, PT.CDPRODESTO,
             (NVL(SUM(I.VRBRUTITEM),0)/NVL(SUM(QTITEMPROD),1))  AS VRBRUTITEM,
             NVL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
             NVL(SUM(QTITEMPROD),1) AS QTITEMPROD,
             SUM(VRTAXADMFATU) VRTAXADMFATU
      FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II,
           PRODFILI P,   PRODUTO PT,    TAXAADMFATUR TX
      WHERE (N.CDFILIAL         = I.CDFILIAL)            AND
            (N.NRLANCTONF       = I.NRLANCTONF)          AND
            (N.CDFILIAPFATU     = P_CDFILIPROC)          AND
            (N.NRAPFATUTNF      = P_NRAPURACFAT)         AND
            (II.CDFILIAL(+)     = I.CDFILIAL)            AND
            (II.NRLANCTONF(+)   = I.NRLANCTONF)          AND
            (II.NRSEQITPROD(+)  = I.NRSEQITPROD)         AND
            (II.CDIMPOSTO(+)    = V_CDIMPOSTO)           AND
            (II.NRITPROIMPOS(+) = '1')                   AND
            (I.CDPRODUTO        = PT.CDPRODUTO)          AND
            (PT.CDPRODESTO      = P.CDPRODUTO)           AND
            (N.CDFILIAPFATU     = P.CDFILIAL)            AND
            (I.CDFILIAL         = TX.CDFILIAL)           AND
            (INSTR(I.CDPRODUTO,NVL(TX.CDPRODUTO,'')) = 1)
      GROUP BY I.CDPRODUTO,   PT.CDPRODESTO

      UNION ALL

      SELECT I.CDPRODUTO, PT.CDPRODESTO,
             (NVL(SUM(I.VRBRUTITEM),0)/NVL(SUM(QTITEMPROD),1))  AS VRBRUTITEM,
             NVL(SUM(II.VRIMPOSTOIT),0) AS VRIMPOSTOIT,
             NVL(SUM(QTITEMPROD),1) AS QTITEMPROD,
             SUM(VRTAXADMFATU) VRTAXADMFATU
      FROM NOTAFISCAL N, ITEMPRODUTO I, ITEMPROIMPOS II,
           PRODFILI P,   PRODUTO PT,    TAXAADMFATUR TX
      WHERE (N.CDFILIAL         = I.CDFILIAL)          AND
            (N.NRLANCTONF       = I.NRLANCTONF)        AND
            (P_CDFILIPROC   IS NULL)                   AND
            (N.CDFILIAPFATU IS NULL)                   AND
            (P_NRAPURACFAT  IS NULL)                   AND
            (N.NRAPFATUTNF  IS NULL)                   AND
            (II.CDFILIAL(+)     = I.CDFILIAL)          AND
            (II.NRLANCTONF(+)   = I.NRLANCTONF)        AND
            (II.NRSEQITPROD(+)  = I.NRSEQITPROD)       AND
            (II.CDIMPOSTO(+)    = V_CDIMPOSTO)         AND
            (II.NRITPROIMPOS(+) = '1')                 AND
            (I.CDPRODUTO        = PT.CDPRODUTO)        AND
            (PT.CDPRODESTO      = P.CDPRODUTO)         AND
            (N.CDFILIAPFATU     = P.CDFILIAL)          AND
            (I.CDFILIAL         = TX.CDFILIAL)         AND
            (INSTR(I.CDPRODUTO,NVL(TX.CDPRODUTO,'')) = 1)
      GROUP BY I.CDPRODUTO,   PT.CDPRODESTO;

   CURSOR C_TIPOOPER IS
    SELECT N.CDTIPOOPER, N.CDFILIAL, N.NRLANCTONF
    FROM NOTAFISCAL N, ITEMPRODUTO I
    WHERE N.CDFILIAL         = I.CDFILIAL                       AND
          N.NRLANCTONF       = I.NRLANCTONF                     AND
          ((N.CDFILIAPFATU   = P_CDFILIPROC)                    OR
           (P_CDFILIPROC IS NULL AND N.CDFILIAPFATU IS NULL))   AND
          ((N.NRAPFATUTNF    =  P_NRAPURACFAT)                  OR
           (P_NRAPURACFAT IS NULL AND N.NRAPFATUTNF IS NULL))   AND
           I.CDPRODUTO        = V_CDPRODUTO;

BEGIN

   V_IDGEROUNF    := 'N';
   V_CONTADOR     := 0;
   V_SOMAALQIMP   := 0;
   V_DESCIT       := 0;
   V_VRTOTADESP   := 0;
   V_VRTXFATNIV   := 0;
   V_VRDESCNFCMP  := 0;
   V_VRRECUIMCMP  := 0;
   V_VRRECUIMDES  := 0;
   V_VRRECUIMDET  := 0;
   V_VRTOTACMP    := 0;
   V_VRTOTCMPSTX  := 0;
   V_VRTOTCMPCTX  := 0;
   V_VRTOTDESSTX  := 0;
   V_VRTOTDESCTX  := 0;
   V_VRDOTPURPASS := 0;
   V_VRLIQUFATU   := 0;
   V_VRTOTCMPSTX  := 0;
   V_VRTOTCMPCTX  := 0;
   V_VRTOTAXAADM  := 0;
   V_VRBASENFCMP  := 0;


---------------------------------------------------------------------------------
-- DELETA OS REGISTROS DA TABELA TEMPORARIA                                  --
---------------------------------------------------------------------------------
   DELETE FROM RELAT_MANDATO
   WHERE NRRELATMANDA = P_SEQUMAND;

   /* FILIAL QUE EST SENDO APURADA (P_FILIAL = FILIPROC)*/
   SELECT MAX(CDFILIAPUR), MAX(DTINIAPURAC)
   INTO V_CDFILIAPUR, V_DTINIAPURAC
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = P_CDFILIPROC   AND
         NRAPURACFAT = P_NRAPURACFAT;

   SELECT MAX(DTINIAPURAC), MAX(DTFIMAPURAC)
   INTO  V_DTINIAPURAC, V_DTFIMAPURAC
   FROM CTRLAPURFAT
   WHERE CDFILIAL    = V_CDFILIAPUR   AND
         DTINIAPURAC < V_DTINIAPURAC;


   SELECT TO_NUMBER(NVL(TRIM(MAX(SUBSTR(PF.DSPARAMFATFI,31,6))),0)),     /*PERCENTUAL DE COMPRAS/REVENDA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,39,2)),                      /*EMPRESA ATACADISTA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,41,2)),                     /*EMPRESA OPERACIONAL*/
          MAX(SUBSTR(PF.DSPARAMFATFI,43,1)),                    /*TAXA DE ADMINISTRACAO*/
          RTRIM(MAX(SUBSTR(PG.DSPARAMFATGE,73,10))),          /*CODIGO DA PRODUTO PARA REVENDA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,49,1)),                /*CALCULO VALOR TOTAL DE COMPRAS*/
          MAX(SUBSTR(PF.DSPARAMFATFI,37,1)),               /*RECUPERAO DE IMPOSTOS*/
          TO_NUMBER(NVL(MAX(RTRIM(SUBSTR(PF.DSPARAMFATFI,63,6))),0)),      /*PERCENTUAL DE DESPESAS*/
          MAX(SUBSTR(PG.DSPARAMFATGE,155,1)),                            /*GERA NF DE PRODUTO PARA REVENDA*/
          MAX(SUBSTR(PF.DSPARAMFATFI,70,2))                            /*TIPO DE OPERACAO  */
   INTO V_VRPCTXADM,   V_CDEMPRATAC,  V_CDEMPROPER,  V_IDTAXAADM,
        V_CDPRGENEREV, V_IDCALCCOMPR, V_IDRECUIMPOS, V_VRPERCDESP,
        V_IDNFPRODREV, V_CDTIPOOPER
   FROM PARAMFILIAL PF, PARAMGERAL PG
   WHERE PF.CDFILIAL = P_CDFILIAPUR;


   V_VRPCTXADM  := V_VRPCTXADM/1000;
   V_VRPERCDESP := V_VRPERCDESP/1000;


   IF (V_CDTIPOOPER IS NULL) OR (V_CDTIPOOPER = '  ') THEN
      V_CDTIPOOPER := '01';
   END IF;

   SELECT MAX(CDSERIE), MAX(CDINSCESTA), MAX(CDINSCMUNI)
   INTO V_SERIE, V_INSCESTA, V_INSCMUNI
   FROM FILIAL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPRATAC;

   SELECT MAX(CDSERIE), MAX(CDINSCESTA), MAX(CDINSCMUNI)
   INTO V_CDSERIE, V_CDINSCATAC, V_CDINSCMUNI
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPRATAC;

   SELECT MAX(CDSERIE)
   INTO V_CDSERIEDESP
   FROM EMPRCNTRFIL F
   WHERE F.CDFILIAL  = V_CDFILIAPUR   AND
         F.CDEMPRESA = V_CDEMPROPER;

   IF  V_CDSERIE IS NULL THEN
      V_CDSERIE    := V_SERIE;
      V_CDINSCATAC := V_INSCESTA;
      V_CDINSCMUNI := V_INSCMUNI;
   END IF;

   IF V_CDSERIEDESP IS NULL THEN
      V_CDSERIE    := V_SERIE;
   END IF;

   SELECT MAX(CDIMPOSTO)
   INTO V_CDIMPOSTO
   FROM IMPOSMRDP
   WHERE IDIMPOMRDP = 'P';

   SELECT  MAX(NVL(VRDESCENTAPU,0))
   INTO V_VRBASENFCMP
   FROM CTRLAPURFAT
   WHERE (NRAPURACFAT = P_NRAPURACFAT)  AND
         (CDFILIAPUR  = P_CDFILIAPUR);

   IF V_VRBASENFCMP <> 0 THEN
      SELECT NVL(SUM(VRBRUTITEM),0), COUNT(IP.CDPRODUTO)
      INTO V_VRDESCNFCMP, V_NUMITENS
      FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX
      WHERE N.CDFILIAPFATU     = P_CDFILIPROC              AND
            N.NRAPFATUTNF      = P_NRAPURACFAT             AND
            IP.CDFILIAL        = N.CDFILIAL                AND
            IP.NRLANCTONF      = N.NRLANCTONF              AND
            IP.CDFILIAL         = TX.CDFILIAL              AND
            (INSTR(IP.CDPRODUTO,NVL(TX.CDPRODUTO,'')) = 1);

      IF V_VRDESCNFCMP <> 0 THEN
         V_VRDESCNFCMP := ((V_VRDESCNFCMP - V_VRBASENFCMP) / V_NUMITENS);
      END IF;
   END IF;

   FOR C_TAXA IN (SELECT IP.CDFILIAL, IP.CDPRODUTO, VRBRUTITEM
                  FROM  ITEMPRODUTO IP, NOTAFISCAL N,  TAXAADMFATUR TX
                  WHERE N.CDFILIAPFATU     = P_CDFILIPROC              AND
                        N.NRAPFATUTNF      = P_NRAPURACFAT             AND
                        N.CDTIPOOPER <> '12'                           AND
                        IP.CDFILIAL        = N.CDFILIAL                AND
                        IP.NRLANCTONF      = N.NRLANCTONF              AND
                        IP.CDFILIAL        = TX.CDFILIAL               AND
                        (INSTR(IP.CDPRODUTO,NVL(TX.CDPRODUTO,'')) = 1)
                   ORDER BY 2) LOOP


      SELECT MAX(IDFATPRODCLI)
      INTO V_IDFATPRODCLI
      FROM PRODFILIFATU
      WHERE CDFILIAL      = C_TAXA.CDFILIAL   AND
            (INSTR(C_TAXA.CDPRODUTO,NVL(CDPRODUTO,'')) = 1) AND
            (CDTPFATPRFIL  = '003');

      V_VRBRUTITEM := (C_TAXA.VRBRUTITEM - V_VRDESCNFCMP);

      SELECT NVL(MAX(VRTAXADMFATU),0)
      INTO V_VRTXFATNIV
      FROM TAXAADMFATUR TX
      WHERE (TX.CDFILIAL  = C_TAXA.CDFILIAL) AND
            (INSTR(C_TAXA.CDPRODUTO,NVL(TX.CDPRODUTO,'')) = 1);

      IF V_VRTXFATNIV <> 0 THEN
          V_VRTAXAADM := ((V_VRBRUTITEM) * (V_VRTXFATNIV / 100));
      ELSE
          V_VRTAXAADM := (V_VRBRUTITEM * (V_VRPCTXADM / 100));
      END IF;

      IF  (V_IDFATPRODCLI  = '1') OR (V_IDFATPRODCLI IS NULL) THEN
         IF V_IDCALCCOMPR = '1' THEN
            V_VRLIQUFATU := V_VRLIQUFATU  + ((V_VRBRUTITEM + NVL(V_VRTAXAADM,0)));
         ELSE
            V_VRLIQUFATU :=  V_VRLIQUFATU + (NVL(V_VRTAXAADM,0));
         END IF;
         V_VRTOTCMPSTX   := (V_VRTOTCMPSTX + V_VRBRUTITEM);
         V_VRTOTCMPCTX   := (V_VRTOTCMPCTX + V_VRTAXAADM);
      ELSIF (V_IDFATPRODCLI  = '2') THEN
          V_VRTOTCMPSTX  := (V_VRTOTCMPSTX + V_VRBRUTITEM);
      END IF;
   END LOOP;

   IF NOT (NVL(V_IDNFPRODREV,'N') = 'S') THEN

      IF V_VRLIQUFATU > 0 THEN

         IF V_IDRECUIMPOS = 'S' THEN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT MAX(NVL(IDENDCFOPFIL,'I')),
                   MAX(CDEMPRESA), MAX(CDINSCESTA)
            INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
            FROM FILIAL
            WHERE (CDFILIAL = P_CDFILIAPUR);

            IF V_IDENDCFOP = 'I' THEN
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM INSCRESTAD
               WHERE CDEMPRESA  = V_CDEMPRESA AND
                     CDINSCESTA = V_CDINSCESTA;
            ELSE
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM ENDEFILI
               WHERE (CDFILIAL     = P_CDFILIAPUR) AND
                     (IDTPENDEFILI = V_IDENDCFOP);
            END IF;

            SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
            INTO V_IDENDCFOP, V_IDENDEMIS
            FROM CLIENTE
            WHERE (CDCLIENTE = P_CDCLIENTE);

            SELECT MAX(CDPAIS), MAX(SGESTADO)
            INTO V_PAISDEST, V_ESTADEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CDCLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE , V_CDFILIAPUR, 'S', V_CDTIPOOPER, V_CDGRUPOFISC);

            /*CALCULO DA ALIQUOTA IMPOSTO*/

            /* ISS */

            CONSULTA_ALIQUOTA('31', 'S',  V_CDEMPRATAC, V_CDPRGENEREV,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DTFINAPUR,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            /* PIS */

            CONSULTA_ALIQUOTA('50', 'S',  V_CDEMPRATAC, V_CDPRGENEREV,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DTFINAPUR,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

             /* COFINS */

            CONSULTA_ALIQUOTA('60', 'S',  V_CDEMPRATAC, V_CDPRGENEREV, V_CDINSCATAC, V_PAISORIG,
                               V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DTFINAPUR,
                               P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

            SELECT NVL(MAX(VRALIQUTMP),0)
            INTO V_VRALIQUTMP
            FROM ALIQTEMP
            WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

            V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

            DELETE ALIQTEMP
            WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

            IF V_SOMAALQIMP <>  0 THEN
                IF V_IDTAXAADM = 'D' THEN  /*POR DENTRO*/
                    V_VRRECUIMCMP := (V_SOMAALQIMP / 100);
                ELSE                       /*POR FORA*/
                    V_VRRECUIMCMP := (100 / (100 - V_SOMAALQIMP));
                END IF;
            END IF;

         END IF;
         V_VRLIQUFATU := (V_VRLIQUFATU * V_VRRECUIMCMP);
         V_IDGEROUNF  := 'S';
         V_VRTOTACMP  := V_VRLIQUFATU;
      END IF;
   END IF;
   /*INCLUSO DOS VALORES CALCULADOS PARA COMPRA*/

   INSERT INTO RELAT_MANDATO
      (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,
       CDPRODCMPMAN,VRTOTACMPSTX, VRTOTACMPCTX, VRPERECIMCMP, VRRECUPIMCMP, VRTOTCMPAPUR)
       VALUES
      (P_CDFILIPROC, P_SEQUMAND, V_CONTADOR, P_CDCLIENTE, P_CDFILIAPUR, P_NRAPURACFAT,
       V_CDPRGENEREV,V_VRTOTCMPSTX,  V_VRTOTCMPCTX, V_SOMAALQIMP, V_VRRECUIMCMP, V_VRTOTACMP);

   V_CONTADOR := V_CONTADOR + 1;

   /*INCLUSO DO ITENS DA DESPESA ADMINISTRATIVAS LANADAS NO FAI*/
   FOR C_DESPESA IN C_DESPADMFATUR LOOP

      V_VRTOTDESSTX := (V_VRTOTDESSTX + C_DESPESA.VRLANCDESFAT);

      IF C_DESPESA.VRTAXADMFATU <> 0  THEN
         V_VRTAXAADM := (C_DESPESA.VRLANCDESFAT * (C_DESPESA.VRTAXADMFATU / 100));
      ELSE
         V_VRTAXAADM := (C_DESPESA.VRLANCDESFAT * (V_VRPERCDESP / 100));
      END IF;

      SELECT MAX(IDFATPRODCLI)
      INTO V_IDFATPRODCLI
      FROM PRODFILIFATU
      WHERE CDFILIAL      = C_DESPESA.CDFILIAL   AND
            (INSTR(C_DESPESA.CDPRODUTO,NVL(CDPRODUTO,'')) = 1)  AND
            (CDTPFATPRFIL  = '003');

      IF  (V_IDFATPRODCLI  = '1') OR (V_IDFATPRODCLI IS NULL) THEN
         V_VRLIQUFATU  := (C_DESPESA.VRLANCDESFAT + NVL(V_VRTAXAADM,0));
         V_VRTOTDESCTX := (V_VRTOTDESCTX + NVL(V_VRTAXAADM,0));
      ELSIF (V_IDFATPRODCLI  = '2') THEN
         V_VRLIQUFATU := (C_DESPESA.VRLANCDESFAT);
      END IF;

      IF V_IDRECUIMPOS = 'S' THEN

         V_SOMAALQIMP  := 0;

         IF V_IDGEROUNF = 'S' THEN

            /*VARIVEIS PARA CONSULTA DE ALQUOTA*/

            SELECT MAX(NVL(IDENDCFOPFIL,'I')),
                   MAX(CDEMPRESA), MAX(CDINSCESTA)
            INTO V_IDENDCFOP, V_CDEMPRESA, V_CDINSCESTA
            FROM FILIAL
            WHERE (CDFILIAL = P_CDFILIAPUR);

            IF V_IDENDCFOP = 'I' THEN
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM INSCRESTAD
               WHERE CDEMPRESA  = V_CDEMPRESA AND
                     CDINSCESTA = V_CDINSCESTA;
            ELSE
               SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
               INTO   V_PAISORIG, V_ESTAORIG, V_MUNIORIG
               FROM ENDEFILI
               WHERE (CDFILIAL     = P_CDFILIAPUR) AND
                     (IDTPENDEFILI = V_IDENDCFOP);
            END IF;

            SELECT NVL(MAX(IDENDCFOPCLI),'P'), NVL(MAX(IDENDEMISCLI),'P')
            INTO V_IDENDCFOP, V_IDENDEMIS
            FROM CLIENTE
            WHERE (CDCLIENTE = P_CDCLIENTE);

            SELECT MAX(CDPAIS), MAX(SGESTADO)
            INTO V_PAISDEST, V_ESTADEST
            FROM ENDECLIE
            WHERE (CDCLIENTE    = P_CDCLIENTE) AND
                  (IDTPENDECLIE = V_IDENDEMIS);

         END IF;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

         CONSULTA_GRUPOFISCAL('C', P_CDCLIENTE , V_CDFILIAPUR, 'S', V_CDTIPOOPER, V_CDGRUPOFISC);

         /*CALCULO DA ALIQUOTA IMPOSTO*/

         /* ISS */

         CONSULTA_ALIQUOTA('31', 'S',  V_CDEMPRATAC, C_DESPESA.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                              V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG,V_VRLIQUFATU, P_DTFINAPUR,
                              P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

         SELECT NVL(MAX(VRALIQUTMP),0)
         INTO V_VRALIQUTMP
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

         V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

         /* PIS */

         CONSULTA_ALIQUOTA('50', 'S',  V_CDEMPRATAC, C_DESPESA.CDPRODUTO,  V_CDINSCATAC, V_PAISORIG,
                           V_ESTAORIG,  V_PAISDEST,  V_ESTADEST, V_MUNIORIG, V_VRLIQUFATU, P_DTFINAPUR,
                           P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

         SELECT NVL(MAX(VRALIQUTMP),0)
         INTO V_VRALIQUTMP
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

         V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

         /* COFINS */

         CONSULTA_ALIQUOTA('60', 'S',  V_CDEMPRATAC,C_DESPESA.CDPRODUTO, V_CDINSCATAC, V_PAISORIG,
                           V_ESTAORIG,  V_PAISDEST,  V_ESTADEST,     V_MUNIORIG, V_VRLIQUFATU, P_DTFINAPUR,
                           P_CDFILIAPUR, P_NRLANCTONF,  V_CDGRUPOFISC);

         SELECT NVL(MAX(VRALIQUTMP),0)
         INTO V_VRALIQUTMP
         FROM ALIQTEMP
         WHERE (NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF);

         V_SOMAALQIMP  := V_SOMAALQIMP + V_VRALIQUTMP;

         DELETE ALIQTEMP
         WHERE NRALIQTEMP = P_CDFILIAPUR||P_NRLANCTONF;

         IF V_SOMAALQIMP <>  0 THEN
            IF V_IDTAXAADM = 'D' THEN  /*POR DENTRO*/
                 V_VRRECUIMDES := (V_SOMAALQIMP / 100);
            ELSE                       /*POR FORA*/
                 V_VRRECUIMDES := (100 / (100 - V_SOMAALQIMP));
            END IF;
        END IF;

      END IF;

      V_VRLIQUFATU := (V_VRLIQUFATU * V_VRRECUIMDES);
      V_VRTOTADESP := (V_VRTOTADESP + V_VRLIQUFATU);

      /*INCLUSO DOS VALORES CALCULADOS PARA DESPESAS ADMINISTRATIVAS*/
      INSERT INTO RELAT_MANDATO
         (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,
          CDPRODCMPDES, VRDESNFCMPAP, VRTAXAADMDES, VRTOTADESSTX, VRTOTADESCTX,
          VRPERECIMDES,VRRECUPIMDES, VRTOTDESAPUR)
          VALUES
         (P_CDFILIPROC, P_SEQUMAND, V_CONTADOR, P_CDCLIENTE, P_CDFILIAPUR, P_NRAPURACFAT,
          C_DESPESA.CDPRODUTO, V_VRBASENFCMP, V_VRTAXAADM, V_VRTOTDESSTX, V_VRTOTDESCTX,
          V_SOMAALQIMP, V_VRRECUIMDES, V_VRTOTADESP);

      V_CONTADOR := V_CONTADOR + 1;
   END LOOP;

   IF (NOT V_IDNFPRODREV = 'S') AND (V_IDGEROUNF = 'S')  THEN
      /* Gerao do Crdito em Relao a Dotao da Apurao Passada */

      SELECT NVL(SUM(VRBRUTITEM),0)
      INTO V_VRDOTPURPASS
      FROM NOTAFISCAL N, ITEMPRODUTO IP
      WHERE  (N.CDFILIEMIT   = P_CDFILIAPUR)                         AND
             (N.IDSTATUS     <> 'C')                                 AND
             (N.CDTIPOOPER   = '12')                                 AND
             (N.IDENTRSAIDOP = 'S')                                  AND
             (N.DTENTRSAID BETWEEN P_DTINIAPUR  AND P_DTFINAPUR) AND
             (IP.CDFILIAL    = N.CDFILIAL)                           AND
             (IP.NRLANCTONF  = N.NRLANCTONF)                         AND
             (IP.IDTPNFCREDEB   = '4');
      IF V_VRDOTPURPASS <> 0 THEN
         INSERT INTO RELAT_MANDATO
            (CDFILIAL, NRRELATMANDA, NRREGRELMAND, CDCLIENTEMA, CDFILIAPURMA, NRAPURACFAMA,VRDOTACAOAPU)
             VALUES
            (P_CDFILIPROC, P_SEQUMAND, V_CONTADOR, P_CDCLIENTE, P_CDFILIAPUR, P_NRAPURACFAT,V_VRDOTPURPASS);
      END IF;
   END IF;
END;
/
